#include "Sprite.h"
#include "VVram.h"
#include "Vram.h"

constexpr byte InvalidY = 0xe0;

struct Sprite {
    byte x, y;
    byte[4] chars;
};
Sprite[SpriteCount] Sprites;


void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
    }
}


void ShowSprite(ptr<Movable> pMovable, ptr<byte> pChars)
{
    ptr<Sprite> p;
    ptr<byte> pDestination;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    pDestination = p->chars;
    repeat(4) {
        *pDestination = *pChars;
        ++pDestination;
        ++pChars;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pVVram, pChar;
            pVVram = VVramFront + VVramOffset(p->x, p->y);
            pChar = p->chars;
            repeat (2) {
                repeat (2) {
                    *pVVram = *pChar; ++pVVram;
                    ++pChar;
                }
                pVVram += VVramWidth - 2;
            }
        }
    }
}
